%define majver 2.01
%define minver 10

Name: webalizer
Version: %majver.%minver
Release: alt4

Summary: Web/ftp/proxy server log analyser
License: GPL
Group: Monitoring

Url: http://www.mrunix.net/%name
Source0: %name-%majver-%minver-src.tar.bz2
Source1: %name.conf

#Requires: db1 libjpeg freetype2 XFree86-libs xpm libintl libpng freetype2 zlib

%define apache_group apache
%define apache_log %_logdir/httpd/access_log
%define vsftpd_log %_logdir/vsftpd.log
%define webalizer_user webalizer
%define webalizer_group webalizer
%define webalizer_home %_localstatedir/%name
%define webalizer_html %_var/www/html/%name

Summary(ru_RU.KOI8-R):   web/ftp/proxy-
Summary(uk_UA.KOI8-U): ̦ Ǧ web/ftp/proxy-Ҧ

# Automatically added by buildreq on Mon Jun 28 2004
BuildRequires: XFree86-libs freetype2 libdb4.2-devel libgd1-devel libpng-devel xpm zlib-devel

%description
The Webalizer is a web server log file analysis program which produces
usage statistics in HTML format for viewing with a browser.  The results
are presented in both columnar and graphical format, which facilitates
interpretation.  Yearly, monthly, daily and hourly usage statistics are
presented, along with the ability to display usage by site, URL, referrer,
user agent (browser) and country (user agent and referrer are only
available if your web server produces combined log format files).

%description -l ru_RU.KOI8-R
The Webalizer --    - web- Apache 
 ,     HTML (  ).
 , ,     
   , URL, , , .

%description -l uk_UA.KOI8-U
The Webalizer --   ̦ -̦ web- Apache 
 ,     Ħ HTML (æ  Ħ).
 Ҧ, ͦ,     
צ   , URL, , , .

%prep
%setup -n %name-%majver-%minver

%build
CFLAGS="%optflags -fsigned-char"
%configure \
	--with-db \
	--with-dblib \
	--enable-dns

# patch the template; keep common data in HOME, distinct in DATA
sed -e "s,__HTML__,%webalizer_html,g" \
    -e "s,__HOME__,%webalizer_home,g" \
    -e "s,__DATA__,%webalizer_home,g" \
    -e "s,__LOGFILE__,%apache_log,g" \
    -e "s,__LOGTYPE__,clf,g" \
< %SOURCE1 \
> apache.conf

sed -e "s,__HTML__,%webalizer_html/ftp,g" \
    -e "s,__HOME__,%webalizer_home,g" \
    -e "s,__DATA__,%webalizer_home/ftp,g" \
    -e "s,__LOGFILE__,%vsftpd_log,g" \
    -e "s,__LOGTYPE__,ftp	# xferlog_std_format=YES to /etc/vsftpd.conf,g" \
< %SOURCE1 \
> vsftpd.conf

%make_build

%install
%__install -d %buildroot%_sysconfdir/{,%name,cron.d}
%__install -d %buildroot%_bindir
%__install -d %buildroot%_docdir
%__install -d %buildroot%webalizer_home
%__install -d %buildroot%webalizer_html
%__install -d %buildroot%_mandir/man1
%__install -m644 sample.conf %buildroot%_docdir/
%__install -m644 apache.conf %buildroot%_sysconfdir/%name/
%__install -m644 vsftpd.conf %buildroot%_sysconfdir/%name/
%__install -m755 webalizer %buildroot%_bindir
%__install -m644 webalizer.1 %buildroot%_man1dir
%__install -m644 webalizer.png %buildroot%webalizer_html
%__install -m644 msfree.png %buildroot%webalizer_html
touch %buildroot%_sysconfdir/%name.conf

%__cat << EOF > %buildroot%_sysconfdir/cron.d/%name
#!/bin/sh
15 03 * * * %webalizer_user %_bindir/%name -c %_sysconfdir/%name/apache.conf
#25 03 * * * %webalizer_user %_bindir/%name -c %_sysconfdir/%name/vsftpd.conf
EOF

%__ln_s webalizer %buildroot/%_bindir/webasolve

%pre
%__grep -q "^%webalizer_group:" %_sysconfdir/group \
|| %_sbindir/groupadd -r -f %webalizer_group ||:
%__grep -q "^%webalizer_user:" %_sysconfdir/passwd \
|| %_sbindir/useradd -g %webalizer_group -G %apache_group -c 'The Webalizer' \
	-d %webalizer_home -s /dev/null -r %webalizer_user ||: 

%post
# get hostname.  This way till we have a macro.
W_HOST=`hostname`
[ $? = 0 ] || W_HOST=localhost
[ $? = 0 ] && {
	%__subst "s,__HOST__,$W_HOST,g" %_sysconfdir/%name/apache.conf ||:
}
[ $? = 0 ] && {
	%__subst "s,__HOST__,$W_HOST,g" %_sysconfdir/%name/vsftpd.conf ||:
}
[ -f "%_sysconfdir/%name.conf" ] && \
echo "NB: default webalizer configuration place is under %_sysconfdir/%name/ now
to allow for easier management of .conf files; you may want to look there
and/or update your setup." ||:

# fix awful user/group deletion in previous spec versions :(
%triggerpostun -- webalizer < 2.01.10-alt3
echo "Fixing permissions after faulty previous package:"
%_sbindir/groupadd -r -f %webalizer_group ||:
%_sbindir/useradd -g %webalizer_group -G %apache_group -c 'The Webalizer' \
	-d %webalizer_home -s /dev/null -r %webalizer_user ||: 
for i in %webalizer_home %webalizer_html; do
	find $i -group %apache_webmaster \( -type f -o -type d \) -print0 \
	| xargs -r0 -- %__chown -Rv root:%webalizer_group
done

%files
%doc CHANGES DNS.README INSTALL README* country-codes.txt sample.conf
%config(noreplace) %_sysconfdir/cron.d/*
%config(noreplace) %verify(not size mtime md5) %_sysconfdir/%name/*
%ghost %config(noreplace,missingok) %verify(not size mtime md5) %_sysconfdir/%name.conf
%_bindir/*
%_man1dir/*
%dir %attr(775,root,%webalizer_group) %webalizer_home
%dir %attr(775,root,%webalizer_group) %webalizer_html
%attr(644,root,%webalizer_group) %webalizer_html/*

# FIXME:
# - wait for pseudouser naming/mgmt policy and fix the package (finally)
# - bak-around userdel -r in early packages?

%changelog
* Mon Jun 28 2004 Michael Shigorin <mike@altlinux.ru> 2.01.10-alt4
- fixed #2977 (in a stylish manner: stuffed ||: all over the place)
- fixed #2623 (userdel issue)
- #2945 (perms on /var/log/httpd) also resolved, so no changes
  on webalizer part needed
- more secure permissions fixup
- minor spec cleanup

* Thu Jul 31 2003 Michael Shigorin <mike@altlinux.ru> 2.01.10-alt3
- removed userdel/groupdel as per proposal; closes #0002623
- moved configuration file(s) to %%_sysconfdir/%%name/
  (default webalizer.conf became webalizer/apache.conf, you
   may need to update cronjob)
- added vsftpd.conf
- reshuffled data dir somewhat (shouldn't touch legacy data)

* Tue Oct 29 2002 Michael Shigorin <mike@altlinux.ru> 2.01.10-alt2
- rebuilt with gcc 3.2

* Tue Jul 09 2002 Michael Shigorin <mike@altlinux.ru> 2.01.10-alt1
- built for ALT Linux (based on Cooker package)
- cronjob and fs permissions adjusted to run webalizer as user
- s/cron.weekly/cron.d/ seems sane to me (more freedom, less hassle)
- more out-of-box tuning introduced (mainly webalizer.conf tweaks)
